// Player class
import java.awt.*;
import FlexLabel;
import FlowLayoutCust;
import tablelayout.*;

public class Player extends Panel{
	private String name;

	private Counter lives;
	private Counter score;

	private static int LIVES = 5;

	public Player(String name){
		super();
		this.name = name;

		setBackground(new Color(50,50,50));
		// init score and lives
		lives = new Counter(LIVES);
		lives.setColor(Color.white);
		
		score = new Counter();
		score.setWidth(50);
		score.setColor(Color.white);
	

		// place into panel
//		setLayout(new FlowLayoutCust(2,5,5));
//		setLayout(new GridLayout(0,1,5,5));
		setLayout(new TableLayout());
		
		FlexLabel label = new FlexLabel(" "+name);
		label.setColor(Color.white);
		label.setFont("Helvetica", Font.BOLD,20);
		label.setWidth(80);
		add("0 0 2 1 hH", label);

		FlexLabel livesLabel = new FlexLabel("Lives : ");
		livesLabel.setColor(Color.lightGray);
		add("0 1 hHW", livesLabel);
		add("1 1 lhHW",lives);

		FlexLabel scoreLabel = new FlexLabel("Score : ");
		scoreLabel.setColor(Color.lightGray);
		add("0 2 hHW", scoreLabel);
		add("1 2 lhHW", score);
		
	}


	public void extraLife(){
		lives.increment(1);
	}


	public void init(){
		lives.set(LIVES);
		score.reset();
	}
	

	public void loseLife() throws GameOverException{
		lives.decrement(1);
	}

	
	public boolean gameOver(){
		return (lives.value() == 0);
	}


	public void incScore(int incValue){
		score.increment(incValue);
	}
	
// end of class Player
}


class Counter extends FlexLabel{
	private int value;
	
	public Counter(int initValue){
		super(Integer.toString(initValue));
		value = initValue;
		setBorder(true);
		setFont("Arial", Font.BOLD,14);
	}


	public Counter(){
		this(0);
	}


	public void increment(int incValue){
		value += incValue;
		redraw();
	}


	public void decrement(int decValue){
		value -= decValue;
		redraw();
	}


	public void reset(){
		value = 0;
		redraw();
	}


	public void set(int setValue){
		value = setValue;
		redraw();
	}


	public int value(){
		return value;
	}


	private void redraw(){
		setText(Integer.toString(value));
	}
	
// end of class Counter	
}
