import java.awt.*;

/** snake ring
*/
public class Ring extends Rectangle{

	private Image ringImage;
	private Point direction;
	private Point coords;
	
	public Ring(Image ringImage, Point coords, Point direction){
		super();
		this.ringImage = ringImage;
		this.direction = direction;
		this.coords = coords;
		
		if(Nibbles.DEBUG > 200)
			System.out.println("New Ring created dir, coord : "+direction+coords);
	}


	public Rectangle getClipRect(){
		return(new Rectangle((coords.x * PlayField.CELL_WIDTH)+PlayField.X_OFFSET,
						(PlayField.HEIGHT-coords.y) * PlayField.CELL_HEIGHT,
						ringImage.getWidth(null),
						ringImage.getHeight(null)));
	}


	public void draw(Graphics g){
		if(Nibbles.DEBUG == 255)
			System.out.println("Drawing Ring at "+coords.x+", "+coords.y);
			
		g.drawImage(ringImage, (coords.x * PlayField.CELL_WIDTH)+PlayField.X_OFFSET,
						(PlayField.HEIGHT-coords.y) * PlayField.CELL_HEIGHT, null);
	}


	public Point getPosition(){
		return coords;
	}


	public String toString(){
	   return("Ring[ Image: "+ringImage+" Direction: "+direction+" Coords: "+coords);
	}

// end of class Ring
}
