import java.awt.*;
import Ring;
import PlayField;

/** snake
*/
public class Snake extends Object{

	private static int MAX_LENGTH = 100; // arbitraire!
	
	FastRingBuffer ring;
	int length;
	Point prevPos;
	Point direction;
	Point tempDirection;
	int growing;
	PlayField parent;
	Image ringImage;
	
	public Snake(PlayField parent, Image ringImage, int origX, int origY, int dirX, int dirY){
		super();
		if(Nibbles.DEBUG > 200)
			System.out.println("New snake created");
		this.parent = parent;
		this.ringImage = ringImage;
		tempDirection = new Point(dirX, dirY);
		direction = tempDirection;
		prevPos = new Point(origX, origY);
		
		ring = new FastRingBuffer(MAX_LENGTH); // array of rings
		ring.push(new Ring(ringImage, new Point(prevPos.x, prevPos.y), new Point(direction.x, direction.y))); //new Ring
		
		growing = 3; // grow a little at the beginning
		
	}


	/** * change direction
	* checks direction is valid
	*/
	public void changeDirection(int x, int y){
		if(Nibbles.DEBUG > 200)
			System.out.println("Snake.changeDirection() called : "+x+", "+y);

		if(!((direction.x == -x)	&& (direction.y == -y))) // if no half turn 
			tempDirection = new Point(x,y);
	}


	public void eat(int growingValue){
		if(Nibbles.DEBUG >= 180)
			System.out.println("Snake.eat() called : "+growingValue);

		growing = growingValue;
	}


	public boolean isGrowing(){
		return (growing != 0);
	}

	public Point getPosition(){
		return prevPos;
	}


	/** main snake method
	* manages snake moves
	*/
	public void creep(){
		if(Nibbles.DEBUG > 200)
			System.out.println("Snake.creep() called");
			
		// move snake
		direction = tempDirection;	
		prevPos.translate(direction.x, direction.y);
		// wrapping
		if(prevPos.x == PlayField.WIDTH)
			prevPos.x = 0;
		else if(prevPos.x < 0)
		   prevPos.x = PlayField.WIDTH-1;
		   
		if(prevPos.y == PlayField.HEIGHT)
			prevPos.y = 0;
		else if (prevPos.y < 0)
			prevPos.y = PlayField.HEIGHT-1;
			
		// add new ring at snake's front
		Ring aRing;
		aRing = new Ring(ringImage, new Point(prevPos.x, prevPos.y), new Point(direction.x, direction.y));
		ring.push(aRing); //new Ring

		// smart redraw here
		aRing.draw(parent.offscreenGraphics);

		// removes tail if not growing
		if(growing == 0){
			aRing =((Ring)ring.pop());
			Point pos = aRing.getPosition();
			
			parent.freeGrid(pos.x, pos.y); // mark grid as free
			

	   // smart redraw here
			parent.clear(aRing.getClipRect());

			
		}
		else{   // growing > 0
			growing--;
			if(Nibbles.DEBUG > 190)
				System.out.println("Growing = "+growing);
		}
	}

	public void draw(Graphics g){
			
		if(Nibbles.DEBUG > 250)
			System.out.println("Snake.draw() called");
			
		Rectangle clipRect = g.getClipRect();
			
		// iterates through rings
		Ring aRing;
		int s = ring.size();
		for( int i = 0; i < s; i++){
   	  aRing=(Ring)(ring.get(i));
   	  
        if(!(clipRect.intersection(aRing.getClipRect())).isEmpty()) // if needs redrawing
   	  		aRing.draw(g);
		}
	}

	
	
// end of class Snake
}
