import java.applet.*;

/* Sounder Thread
	Loads and plays sounds on demand
*/

public class Sounder extends Thread{

	private static int NUM_AUDIOCLIPS = 3;

	public static int DEAD = 0;
	public static int LEVEL = 1;
	public static int STAR = 2;

	private AudioClip[] clip;

	private int clipIndex = 0;
	
	
	public Sounder(Applet applet){
		super();
		clip = new AudioClip[NUM_AUDIOCLIPS];
		if(Nibbles.DEBUG != 0)
			System.out.println("Loading AudioClips...");

		clip[DEAD] = applet.getAudioClip(applet.getCodeBase(),"sounds/dead.au");
		clip[LEVEL] = applet.getAudioClip(applet.getCodeBase(),"sounds/level.au");
		clip[STAR] = applet.getAudioClip(applet.getCodeBase(),"sounds/star.au");

		start();
	}

	public synchronized void run(){
		while(true){
			try{
				wait();
				clip[clipIndex].play();
			}catch(InterruptedException e){System.out.println(e);}
		}
	}


	public synchronized void play(int index){
		clipIndex = index;
		notify();
	}
		
// end of class Sounder
}
