import java.awt.*;

/** star class
*/
public class Star extends Rectangle{

	Graphics offscreenGraphics;
	Image starImage;
	static int starNumber = 0;
	int x,y;
	
	public Star(Graphics offscreenGraphics, Image starImage, int x, int y){
		super();
		this.offscreenGraphics = offscreenGraphics;      // used for redrawing
		this.starImage	= starImage;
		starNumber++;
		this.x = x;
		this.y = y;
		if(Nibbles.DEBUG == 255)
			System.out.println("New Star created, Image Size = "+starImage.getWidth(null)+", "+starImage.getHeight(null));
	   resize(starImage.getWidth(null), starImage.getHeight(null));
	   draw(offscreenGraphics);
	}


	public int number(){
		return starNumber;
	}


	public Rectangle getClipRect(){
		return(new Rectangle(x * PlayField.CELL_WIDTH,
						(PlayField.HEIGHT-y) * PlayField.CELL_HEIGHT,
						starImage.getWidth(null),
						starImage.getHeight(null)));
	}

	
	public void draw(Graphics g){
		if(Nibbles.DEBUG == 255)
			System.out.println("Drawing Star at "+x+", "+y);
			
		g.drawImage(starImage, (x * PlayField.CELL_WIDTH)+PlayField.X_OFFSET,
						(PlayField.HEIGHT-y) * PlayField.CELL_HEIGHT, null);

	}


	public static void reset(){
		starNumber = 0;
	}
	
// end of class star
}
